︠e7335f88-5195-4cd8-8702-feaa978272bb︠
w=6; # Width of data to check
k=3; # Number of multiples of w to store as state (greater numbers increases safety)
n=w*k; # Number of bits of state
︡15522e9a-3403-432f-b6cd-5ebf526ff836︡︡
︠64423b27-2113-4bc3-9307-8999c3092d29︠
# Find some maximal length matrix for the underlying generator,
# so that if we get a sequence of zeros (for example), then the
# system keeps going
def make_A(t):
    while true:
        M=matrix(GF(2),n,n);
        for i in range(0,n):
            M[i,(i+w-1)%n]=1;
        for i in range(0,w):
            for j in range(1,t):
                M[i,randint(0,n-1)]=1;
        if not M.is_invertible():
            continue;
        if M.multiplicative_order()==2^n-1:
            return M;
︡882f87f9-c535-4399-b328-e013b61737a8︡︡
︠ffc25a04-0a2a-4c3e-8e96-b4b07522169a︠
# Find another matrix such that [A^(k-1)B ; A^(k-2)B;...;A*B;B] is invertible
def make_B(A,t=1):
    while true:
        B=matrix(GF(2),n,w);
        p=Permutations(w).random_element();
        for i in range(0,w):
            B[i,p[i]-1]=1;
        T=matrix(GF(2),n,0);
        F=identity_matrix(GF(2),n);
        for i in range(0,k):
            T=T.augment(F*B);
            F=F*A;
        if not T.is_invertible():
            return B;
︡5ae014cd-75f7-47e0-a733-5030297d7fb8︡︡
︠0aa74437-1740-41e8-90d5-7736acc57fe7︠
def dump_taps(A,B):
    for i in range(0,n):
        print "x[%d] = 0 "%i,
        for j in range(0,n):
            if A[i][j]:
                print "^x[%d]"%j,
        for j in range(0,w):
            if B[i][j]:
                print "^s[%d]"%j,
        print ";";
︡c2ab1ff3-2531-445f-82a2-4648164192d4︡︡
︠502fbb2a-2c00-4a27-acba-adfa294e87ae︠
A=make_A(3); print A.str()
︡0a9b30bc-f4ef-4f69-ac97-9da6fc7ae764︡{"stdout": "[0 0 0 0 0 1 0 0 0 0 0 0 0 1 0 0 1 0]\n[0 0 0 0 0 0 1 0 0 0 0 0 1 0 0 0 0 0]\n[0 0 0 0 0 0 0 1 0 0 0 0 0 1 0 0 1 0]\n[0 0 0 0 0 0 0 0 1 1 0 0 1 0 0 0 0 0]\n[0 0 0 0 0 1 1 0 0 1 0 0 0 0 0 0 0 0]\n[0 0 0 1 0 0 0 0 0 0 1 0 0 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1]\n[1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0]"}︡
︠5cbee101-649c-4a01-a6ff-9a8459afa920︠
B=make_B(A,1); B
︡34d65eea-bf23-4aa8-bcd6-2e510440d6ab︡{"stdout": "[0 0 1 0 0 0]\n[0 0 0 0 1 0]\n[0 0 0 1 0 0]\n[0 0 0 0 0 1]\n[1 0 0 0 0 0]\n[0 1 0 0 0 0]\n[0 0 0 0 0 0]\n[0 0 0 0 0 0]\n[0 0 0 0 0 0]\n[0 0 0 0 0 0]\n[0 0 0 0 0 0]\n[0 0 0 0 0 0]\n[0 0 0 0 0 0]\n[0 0 0 0 0 0]\n[0 0 0 0 0 0]\n[0 0 0 0 0 0]\n[0 0 0 0 0 0]\n[0 0 0 0 0 0]"}︡
︠897ec17e-a06f-427c-9afc-10a1dc981193︠
dump_taps(A,B)
︡965d66cc-54d1-4036-bdb6-3f304a3bdd1a︡{"stdout": "x[0] = 0  ^x[5] ^x[13] ^x[16] ^s[2] ;\nx[1] = 0  ^x[6] ^x[12] ^s[4] ;\nx[2] = 0  ^x[7] ^x[13] ^x[16] ^s[3] ;\nx[3] = 0  ^x[8] ^x[9] ^x[12] ^s[5] ;\nx[4] = 0  ^x[5] ^x[6] ^x[9] ^s[0] ;\nx[5] = 0  ^x[3] ^x[10] ^s[1] ;\nx[6] = 0  ^x[11] ;\nx[7] = 0  ^x[12] ;\nx[8] = 0  ^x[13] ;\nx[9] = 0  ^x[14] ;\nx[10] = 0  ^x[15] ;\nx[11] = 0  ^x[16] ;\nx[12] = 0  ^x[17] ;\nx[13] = 0  ^x[0] ;\nx[14] = 0  ^x[1] ;\nx[15] = 0  ^x[2] ;\nx[16] = 0  ^x[3] ;\nx[17] = 0  ^x[4] ;"}︡
︠2151981c-8d9b-40cf-af53-65f58147e426︠
def make_data(count):
    return random_matrix(GF(2),w,count);

def corrupt_data(data,n):
    M=matrix(GF(2),data.nrows(),data.ncols());
    G=copy(data);
    for i in range(0,n):
        while true:
            r=randint(0,data.nrows()-1);
            c=randint(0,data.ncols()-1);
            if M[r,c]==0:
                break;
        M[r,c]=1;
        G[r,c]=not G[r,c];
    return G;
    
def count_errors(data,got):
    return len((data-got).nonzero_positions());

def run_check(A,B,data):
    s=vector(GF(2),n);
    for i in range(0,n):
        s[i]=1;
    for i in range(0,data.ncols()):
        s=A*s+B*data.column(i);
    return s;

def calc_states(A,B,data):
    s=vector(GF(2),n);
    for i in range(0,n):
        s[i]=1;
    res=matrix(GF(2),n,0);
    res=res.augment(s);
    for j in range(0,data.ncols()):
        s=A*s+B*data.column(j);
        res=res.augment(s);
    return res;
    
def run_trial(A,B,count,nerrs):
    D=make_data(count);
    G=corrupt_data(D,nerrs);
    rs=run_check(A,B,D);
    gs=run_check(A,B,G);
    return rs==gs;
︡37ac8b64-8fc6-48fd-a19f-512b1aeace5a︡︡
︠5f0e690b-084c-4d4f-b935-f1052354ea41︠
def plot_fails(A,B,count,reps):
    points=[];
    for nerrs in range(0,2*n):
        acc=0;
        for rep in range(0,reps):
            if run_trial(A,B,count,nerrs):
                acc=acc+1;
        points.append([nerrs,acc/reps]);
    return list_plot(points);
︡96140d11-ce1a-4060-8486-a0ba265a30bd︡︡
︠a0a61bd3-bcd6-4ae2-8551-cab4817e3d47︠
plot_fails(A,B,1000,n)
︡0e498d5f-8a2b-43b8-ac64-d98ea08b8ea8︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
